ACM/ICPC 沈阳网络赛 1004 (nlogn最长上升子序列)

来源:互联网 发布:大学生网络兼职 编辑:程序博客网 时间:2024/06/02 19:22

array array array

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 612    Accepted Submission(s): 354


Problem Description
One day, Kaitou Kiddo had stolen a priceless diamond ring. But detective Conan blocked Kiddo's path to escape from the museum. But Kiddo didn't want to give it back. So, Kiddo asked Conan a question. If Conan could give a right answer, Kiddo would return the ring to the museum. 
Kiddo: "I have an array A and a number k, if you can choose exactly k elements from A and erase them, then the remaining array is in non-increasing order or non-decreasing order, we say A is a magic array. Now I want you to tell me whether A is a magic array. " Conan: "emmmmm..." Now, Conan seems to be in trouble, can you help him?
 

Input
The first line contains an integer T indicating the total number of test cases. Each test case starts with two integers n and k in one line, then one line with nintegers: A1,A2An.
1T20
1n105
0kn
1Ai105
 

Output
For each test case, please output "A is a magic array." if it is a magic array. Otherwise, output "A is not a magic array." (without quotes).
 

Sample Input
34 11 4 3 75 24 1 3 1 26 11 4 3 5 4 6
 

Sample Output
A is a magic array.A is a magic array.A is not a magic array.
题意:给个序列,长度为n,让你从中删除k个数,问这个序列能否成为非递减或非递增序列。
思路:nlogn 最长子序列,low_bound找的是大于等于某个数的位置,那么就会有相同的元素会被 dp[i]=min(dp[i],a[j])替换掉,这是不符合题意的,我们只找大于a[i]的元素,所以找a[i]+1就行,即low_bound(dp,dp+n,a[i]+1)=a[i];
所以当最长递增子序列>=n-k的时候,就能找到;
#include<bits/stdc++.h>using namespace std;#define maxn 100005#define inf 0x3f3f3f3fint a[maxn];int dp1[maxn],dp2[maxn];int main(){    int t,n,k;    scanf("%d",&t);    while(t--)    {         scanf("%d%d",&n,&k);        fill(dp1,dp1+n,inf);        for(int i=0;i<n;i++){            scanf("%d",&a[i]);        }        for(int i=0;i<n;i++){            *lower_bound(dp1,dp1+n,a[i]+1)=a[i];//找到第一个大于等于a[i]的位置;               //cout<<*lower_bound(dp1,dp1+n,a[i])<<endl;    }    int ans1=lower_bound(dp1,dp1+n,inf)-dp1;    //cout<<ans1<<endl;    fill(dp2,dp2+n,inf);    for(int i=n-1;i>=0;i--){        *lower_bound(dp2,dp2+n,a[i]+1)=a[i];//dp[i]=min(dp[i],a[j])    }    int ans2=lower_bound(dp2,dp2+n,inf)-dp2;   // cout<<ans2<<endl;    if(ans1>=n-k||ans2>=n-k) cout<<"A is a magic array."<<endl;    else cout<<"A is not a magic array."<<endl;   }}


原创粉丝点击